#!/usr/bin/env python3

import socketserver
import signal
import time

IP_ADDR = "0.0.0.0"
PORT = 4321

def challenge(req):
    while True:    
        try:
            req.sendall(b'Welcome to basic TCP server.\n'+\
                    b'[1] Option 1.\n' +\
                    b'[2] Option 2.\n' +\
                    b'[3] Option 3.\n' +\
                    b'[4] Option 4.\n')            

            opt = req.recv(4096).decode().strip()

            if opt == "1":
                req.sendall(b"Nice choice!\n")
            elif opt == "2":
                req.sendall(b"Ok, but could be better!\n")
            elif opt == "3":
                req.sendall(b"Not bad :D\n")
            elif opt == "4":
                req.sendall(b"This is it.\n")
            else:
                req.sendall(b"Baaad choice\n")

        except Exception as e:
            print(e)
            req.sendall(b'Invalid Input. Exit!')
            exit(1)

# -------------------------
        
class incoming(socketserver.BaseRequestHandler):
    def handle(self):
        challenge(self.request)

class ReusableTCPServer(socketserver.ForkingMixIn, socketserver.TCPServer):
    pass

# -------------------------

def main():
    global IP_ADDR, PORT
    socketserver.TCPServer.allow_reuse_address = True
    server = ReusableTCPServer((IP_ADDR, PORT), incoming)
    print(f"Listening on ({IP_ADDR}, {PORT})")    
    server.serve_forever()

if __name__ == "__main__":
    main()
